-- ChatBot module

local config = {
	botname = "ChatBot"
}

local module = {
	name = "chatbot",
	path = nil,
	-- will be set by the main script	

	config = config,
	bot = nil,
	replies = { },	

	getinfo = function(self)
		return {
			name = "ChatBot v0.1",
			about = "ChatBot v0.1"..
			"\013\010  2003 by wintermute"
		}
	end,
	
	chatrecieved = function(self, user, text)
		local longestkey = ""
		for key, item in self.replies do				
			if strfind(" "..strlower(text).." ", key) then
				if strlen(key) > strlen(longestkey) then
					longestkey = key
				end
			end
		end
		if longestkey ~= "" then
			local choices = self.replies[longestkey]
			local a = random(100)
			local n = 0
			local reply
			for i = 1, getn(choices) do
				n = n + choices[i].probability
				if a <= n then
					reply = choices[i].reply
					break
				end
			end
			if reply then
				local vars = {
					user = user.sName
				}
				self.bot:delayedchat(replacevars(reply, vars))
			end
		end
	end,

	run = function(self)
		self.bot = new_bot(self.config.botname)
		self.bot:enter()

		f = openfile(self.path.."replies.txt", "r")
		if f then
			local key
			local line = read(f)
			while line do
				local s, e, newkey = strfind(line, "%[(.+)%]")
				if newkey then
					key = newkey
					self.replies[key] = { }
				elseif key then
					local s, e, probability = strfind(line, "(%d+)%|.+")
					local s, e, reply = strfind(line, "%d+%|(.+)")
					if not (probability and reply) then
						probability = 100
						reply = line
					else
						probability = tonumber(probability)
					end
					local item = {
						probability = probability,
						reply = reply
					}
					tinsert(self.replies[key], item)
				end
				line = read(f)
			end
		end
	end,
}

modules:add(module)