-- Foo module

local module = {
	name = "foo",
	path = nil,
	-- will be set by the main script
	
	getinfo = function(self)
		return {
			name = "Foo Module v0.123",
			about = "Foo Module v0.123"..
			"\013\010  2003 by wintermute"
		}
	end,
	
	getnewprivileges = function(self)
		return {
			privilege1 = 1,
			privilege2 = 1
		}
	end,
	
	command = function(self, user, cmdname, arg)
		if cmdname == "foo" then
			return 1, messages.somefoomessage
		end
		return false
		-- return 1 for processed, false for unprocessed
	end,

	pmrecieved = function(self, user, text)
		mainbot:chat("Foo module: "..user.sName.." sent me a message!")
	end,
	chatrecieved = function(self, user, text)
		mainbot:delayedchat("Foo module: "..user.sName.." is talking!")
	end,
	run = function(self)
		mainbot:chat("Running Foo module..")
	end,
	newuserconnected = function(self, user)
		mainbot:pm(user, "Hi there!")
	end,	
	opconnected = function(self, user)
		mainbot:pm(user, "Hi there!")
	end,	
	opdisconnected = function(self, user)
	end
}

modules:add(module)